var _ = require("underscore");

var slice = Array.prototype.slice;
var extending = false;

var class_methods;
class_methods = {
  initialize: function(instance) {
    this.prototype.initialize.apply(instance, slice.call(arguments, 1));
  },
  
  mixin: function(/* modules */) {
    var prototype = this.prototype;
    
    _.each(arguments, function(module) {
      _.extend(prototype, _.isFunction(module) ? module.prototype : module);
    });
  },
  
  extend: function(/* modules, */ prototype) {
    var ctor = function() {
      if (!extending) this.initialize.apply(this, arguments);
    };
    
    try {
      extending = true;
      ctor.prototype = new this();
    } finally {
      extending = false;
    }
    _.extend(ctor, class_methods);
    ctor.prototype.constructor = ctor;
    ctor.mixin.apply(ctor, arguments);
    
    return ctor;
  }
};

// Bootstrap the primary class hierarchy
module.exports = class_methods.extend.call(Object, {
  initialize: function() {}
});
